#include "CWeightRand.h"

CWeightRand::CWeightRand()
{
  m_b_needs_computation = true;
}

int CWeightRand::GetOdds(int i_choice)
{
    return a_odds[i_choice];
}

void CWeightRand::Clear()
{
    a_odds.clear();
    a_computed_odds.clear();
    m_b_needs_computation = true;

}

void CWeightRand::AddChoice(int i_index, int i_odds)
{
    if (i_index+1 > a_odds.size())
    {
    
    a_odds.resize(i_index+1); //make sure it's big enough
    a_computed_odds.resize(i_index+1); //make sure it's big enough
    }
    a_odds[i_index] = i_odds;
    m_b_needs_computation = true;
}


void CWeightRand::ComputeOdds()
{
    //cycle through and figure out the percentages

    long l_total = 0;    
    for (int i=0; i < a_odds.size(); i++)
    {
      l_total += a_odds[i];
    }



    for (i=0; i < a_odds.size(); i++)
    {
      a_computed_odds[i] = float(a_odds[i])/ float(l_total);
    float test = a_computed_odds[i];
    }


    m_b_needs_computation = false; //all done, ready to compute crap

}

int CWeightRand::GetRandom()
{

    if (m_b_needs_computation) this->ComputeOdds();
    
    float f_rand = ((float)rand() / RAND_MAX);

    //scroll through and figure out which thing we chose
      
    float f_temp = 0;
    
    for (int i=0; i < a_computed_odds.size(); i++)
    {
      f_temp += a_computed_odds[i];
      if (f_temp > f_rand)
      {
          //this must be it.
          return i;
      }
    }


   return 0;
}


